Kea: isc::util::CSCallbackSetList Class Reference

| Kea 3.2.0-git

isc::util::CSCallbackSetList Class Reference

Maintains list of unique CSCallbackSets. More...

`#include <multi_threading_mgr.h>`

## Public Member Functions
| CSCallbackSetList ()
| Constructor.
void | addCallbackSet (const std::string &name, const CSCallbackSet::Callback &check_cb, const CSCallbackSet::Callback &entry_cb, const CSCallbackSet::Callback &exit_cb)
| Adds a callback set to the list.
const std::list< CSCallbackSet > & | getCallbackSets ()
| Fetches the list of callback sets.
void | removeAll ()
| Removes all callbacks from the list.
void | removeCallbackSet (const std::string &name)
| Removes a callback set from the list.

## Detailed Description

Maintains list of unique CSCallbackSets.

The list emphasizes iteration order and speed over retrieval by name. When iterating over the list of callback sets, they are returned in the order they were added, not by name.

Definition at line 71 of file multi_threading_mgr.h.

## Constructor & Destructor Documentation

## ◆ CSCallbackSetList()

isc::util::CSCallbackSetList::CSCallbackSetList | ( |  | ) |
| inline

Constructor.

Definition at line 74 of file multi_threading_mgr.h.

## Member Function Documentation

## ◆ addCallbackSet()

void isc::util::CSCallbackSetList::addCallbackSet | ( | const std::string & | name,
|  | const CSCallbackSet::Callback & | check_cb,
|  | const CSCallbackSet::Callback & | entry_cb,
|  | const CSCallbackSet::Callback & | exit_cb )

Adds a callback set to the list.

Parameters

  name | Name of the callback to add.
  check_cb | The check permissions callback to add.
  entry_cb | The CriticalSection entry callback to add.
  exit_cb | The CriticalSection exit callback to add.

Exceptions

  BadValue | if the name is already in the list, the name is blank, or either callback is empty.

Definition at line 248 of file multi_threading_mgr.cc.

References isc_throw.

## ◆ getCallbackSets()

const std::list< CSCallbackSet > & isc::util::CSCallbackSetList::getCallbackSets | ( |  | ) |

Fetches the list of callback sets.

Definition at line 297 of file multi_threading_mgr.cc.

## ◆ removeAll()

void isc::util::CSCallbackSetList::removeAll | ( |  | ) |

Removes all callbacks from the list.

Definition at line 292 of file multi_threading_mgr.cc.

## ◆ removeCallbackSet()

void isc::util::CSCallbackSetList::removeCallbackSet | ( | const std::string & | name | ) |

Removes a callback set from the list.

Parameters

  name | Name of the callback to remove. If no such callback exists, it simply returns.

Definition at line 282 of file multi_threading_mgr.cc.

The documentation for this class was generated from the following files:

- multi_threading_mgr.h
- multi_threading_mgr.cc